package com.ho.test.aop.cache.service;

import java.rmi.server.UID;
import java.util.Calendar;

/**
 * <p>Title: ServiceToCache</p>
 * <p>Copyright: Copyright (c) 2011</p>
 * <p>Company: HUO</p>
 * 
 * @author Huseyin OZVEREN
 */
public class ServiceToCache implements IServiceToCache {
	// -------------------------------------------------------------- CONSTANTS
	private static int numero = 0;

	// ----------------------------------------------------- PRIVATE ATTRIBUTES
	// ------------------------------------------------------------- EXCEPTIONS
	// ------------------------------------------------------- INTERNAL CLASSES
	// ----------------------------------------------------------- CONSTRUCTORS
	// --------------------------------------------------------- PUBLIC METHODS

	/**
	 * This method should wait 2 seconds and return the result.
	 */
	public String method1ToCache() {
		pWait(2000);
		String output = "result..." + (new UID()).toString();
		return output;
	}

	public String method1ToCache(String valeur) {
		System.out.println("excution de method1ToCache, valeur = " + valeur);
		return valeur + numero++ + ".txt";
	}

	public String method2() {
		return "test..." + (new UID()).toString();
	}

	public String method3() {
		String output = "result3...." + (new UID()).toString();
		return output;
	}

	// ---------- METHODS CACHE cleaner 
	public String save() {
		String output = "save...." + (new UID()).toString();
		return output;
	}
	
	public String delete() {
		String output = "delete...." + (new UID()).toString();
		return output;
	}
	
	public String update() {
		String output = "update...." + (new UID()).toString();
		return output;
	}
	
	public String saveOrUpdate() {
		String output = "saveOrUpdate...." + (new UID()).toString();
		return output;
	}
	
	
	// -------------------------------------------------------- PRIVATE METHODS
	private void pWait(long time) {
		long begin = Calendar.getInstance().getTimeInMillis();
		while ((Calendar.getInstance().getTimeInMillis() - begin) < time)
			;
	}
	// ------------------------------------------------------ PROTECTED METHODS
	// --------------------------------------------- ADVANCED GETTERS & SETTERS
	// ------------------------------------------------------ GETTERS & SETTERS
}