package com.ho.test.aop.cache.spring.utils;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import com.ho.test.aop.cache.service.IServiceToCache;

public class SpringContextLoader implements ServletContextListener {

	// -------------------------------------------------------------- CONSTANTS
	// ----------------------------------------------------- PRIVATE ATTRIBUTES
	// ------------------------------------------------------------- EXCEPTIONS
	// ------------------------------------------------------- INTERNAL CLASSES
	// ----------------------------------------------------------- CONSTRUCTORS
	// --------------------------------------------------------- PUBLIC METHODS
	/**
	 * Method contextDestroyed
	 * @param arg0
	 * @see javax.servlet.ServletContextListener#contextDestroyed(javax.servlet.ServletContextEvent)
	 */
	public void contextDestroyed(ServletContextEvent arg0) { }

	/**
	 * Method contextInitialized
	 * @param arg0
	 * @see javax.servlet.ServletContextListener#contextInitialized(javax.servlet.ServletContextEvent)
	 */
	public void contextInitialized(ServletContextEvent ctx) {
		String springFileName = ctx.getServletContext().getInitParameter("CONFIG_SPRING_FILE");
		ApplicationContextContainer.getInstance(springFileName, ctx.getServletContext());
		
		
		// Code only for MBEAN tests:
		{
			IServiceToCache service = (IServiceToCache) ApplicationContextContainer.getBean("serviceToCache");
			String output1, output2;
			output1 = service.method1ToCache();
			output2 = service.method2();
			output1 = service.method1ToCache("test");
			output2 = service.method3();
			
		} // end-if
	}

	// -------------------------------------------------------- PRIVATE METHODS
	// ------------------------------------------------------ PROTECTED METHODS
	// --------------------------------------------- ADVANCED GETTERS & SETTERS
	// ------------------------------------------------------ GETTERS & SETTERS
}
